This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 855041

Summary: Socket Binding property for Broadcast Group resources should be drop down select box
Product: [Other] RHQ Project Reporter: Armine Hovsepyan <ahovsepy>
Component: PluginsAssignee: RHQ Project Maintainer <rhq-maint>
Status: NEW --- QA Contact: Mike Foley <mfoley>
Severity: unspecified Docs Contact:
Priority: medium    
Version: JON 3.1.1CC: hrupp, jshaughn, mfoley, mithomps, snegrea
Target Milestone: ---   
Target Release: RHQ 4.13   
Hardware: i386   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 855983 (view as bug list) Environment:
Last Closed: Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 855983, 707223    

Description Armine Hovsepyan 2012-09-06 10:43:29 EDT
Description of problem:
The Socket Binding property for Broadcast Group resources is not a drop down select box but a text box, which creates "{JBAS014771: Services with missing/unavailable dependencies=[jboss.messaging.default.jms.connection-factory.ssd Missing[JBAS014861: <one or more transitive dependencies>]]}, rolled-back=true" exception on creating Connection Factory or Pooled Connection Factory resources.

Version-Release number of selected component (if applicable):
JON 3.1.1 ER2
EAP 6.0.0 GA

How reproducible:
always

Steps to Reproduce:
1. Start EAP in full-ha mode
2. Inventory EAP
3. Create a Broadcast Group resource giving a any text for Socket Binding property
4. Create Connection Factory resource giving JNDI name and discovery-group-name
  
Actual results:
"{JBAS014771: Services with missing/unavailable dependencies=[jboss.messaging.default.jms.connection-factory.ssd Missing[JBAS014861: <one or more transitive dependencies>]]}, rolled-back=true" exception is visible

Expected results:
Connection Factory resource is created

Additional info:
Comment 1 Mike Thompson 2012-09-06 17:45:58 EDT
This is a latency issue that amplified due to the fact that there is nested calls in ResourceConfigurationEditView.java. The first call grabs the configuration data and the second (nested call grabs the dependent data values). The second call must wait for the first call to complete further intensifying the problem.

A couple solutions exist. One solution is to just unwind the nested calls making them parallel async instead. This problem would probably require a countdown latch or something similar (cyclic barrier) to synchronize the populating of the data after the 2 independent async calls complete. The first call must complete before we can create the widget to populate with the dependent data values.

Another solution to speed up the solution is to pre-create the widgets up front and only use the gwt rpc async callbacks to populate the data. The screen can actually be drawn (and even cached) and whenever the data comes back the widgets get populated. Because we are choosing the type of widget based on the data coming back we must create all the widget types and hide them and then when we get the config data back we can un-hide the proper widget and populate with dependent data.
Comment 2 Stefan Negrea 2012-09-06 17:58:44 EDT
Because the user was presented with the option to freely enter text (please see comment #1 for the reason), the Broadcast Group was created with the wrong socket binding configuration since the user typed a random string. This in turn made the HornetQ to be marked as down by the AS7 server. The HornetQ can only be partially configured until the bad Broadcast Group resource is deleted.

The AS7 server configuration is not invalidated by this, the only affected component is the actual HornetQ server. So the AS7 server can be reloaded/restarted but the HornetQ server can only be partially configured. For example, no child resources can be created. Once the user deletes the wrongly configured Broadcast Group the HornetQ server returns to normal.
Comment 3 Heiko W. Rupp 2014-05-08 10:43:01 EDT
Bump the target version now that 4.11 is out.